/***************************************************************************
 *  Copyright (c) 2005 Chih-Chung Chang                                    *
 *  Parts copyright (c) 2006 Michael Olson                                 *
 *  Copyright (C) 2007-2008 by Fehmi "Canavar" SAGLAM                      *
 *  canavar@fehmicans.net                                                  *
 *                                                                         *
 *  This file is part of sTerm.                                            *
 *                                                                         *
 *  sTerm is free software; you can redistribute it and/or modify          *
 *  it under the terms of the GNU General Public License as published by   *
 *  the Free Software Foundation; either version 3 of the License, or      *
 *  (at your option) any later version.                                    *
 *                                                                         *
 *  sTerm is distributed in the hope that it will be useful,               *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *  GNU General Public License for more details.                           *
 *                                                                         *
 *  You should have received a copy of the GNU General Public License      *
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>   *
 ***************************************************************************/

#ifndef _stermkeyboard_h__
#define _stermkeyboard_h__

#include "stermsection.h"

class StermKeyboard
{
   private:
           StermSection *sections[10];
           int section_count;
           int cur_section_id;
   public:
          StermKeyboard( int section_count );
          StermKeyboard( int section_count, StermSection *section_list[] );
          ~StermKeyboard();
          void AddSection( int section_id, StermSection *section );
          StermSection * GetCurrentSection();
          StermSection * GetSection(int section_id);
          void SelectSection( int section_id );
          void UnSelectSection( int section_id );
          int MoveLeft();
          int MoveRight();
          string Get_Val();  
          string Get_Shift_Val();   
          string Get_Ctrl_Val();                
	  void Select(int col, int row); // touchscreen select
};
#endif
