/***************************************************************************
 *  Copyright (c) 2005 Chih-Chung Chang                                    *
 *  Parts copyright (c) 2006 Michael Olson                                 *
 *  Copyright (C) 2007-2008 by Fehmi "Canavar" SAGLAM                      *
 *  canavar@fehmicans.net                                                  *
 *                                                                         *
 *  This file is part of sTerm.                                            *
 *                                                                         *
 *  sTerm is free software; you can redistribute it and/or modify          *
 *  it under the terms of the GNU General Public License as published by   *
 *  the Free Software Foundation; either version 3 of the License, or      *
 *  (at your option) any later version.                                    *
 *                                                                         *
 *  sTerm is distributed in the hope that it will be useful,               *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *  GNU General Public License for more details.                           *
 *                                                                         *
 *  You should have received a copy of the GNU General Public License      *
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>   *
 ***************************************************************************/

#ifndef _stermsection_h__
#define _stermsection_h__

#include "stermbutton.h"

class StermSection
{
      private:
              StermButton *buttons[3][20];
              int rows,
                  cols;
              int top, // coordinates of the top left corner of the section
                  left;
              int cur_button_i,
                  cur_button_j;    
				  bool selectable;  
      public:
             StermSection( int rows,
                           int cols,
                           bool selectable = true
                           );
             ~StermSection();
             void AddButton( StermButton *button,
                             int row,
                             int col
                             );
             void SelectButton( int button_i = 0,
                                int button_j = 0
                                );
             void UnSelect();
             void MoveUp();
             void MoveDown();
             void MoveLeft();
             void MoveRight();  
             string Get_Val();             
             string Get_Shift_Val();  
             string Get_Ctrl_Val();      
	     bool isSelectable();           
};

#endif
