/***************************************************************************
 *  Copyright (c) 2005 Chih-Chung Chang                                    *
 *  Parts copyright (c) 2006 Michael Olson                                 *
 *  Copyright (C) 2007-2008 by Fehmi "Canavar" SAGLAM                      *
 *  canavar@fehmicans.net                                                  *
 *                                                                         *
 *  This file is part of sTerm.                                            *
 *                                                                         *
 *  sTerm is free software; you can redistribute it and/or modify          *
 *  it under the terms of the GNU General Public License as published by   *
 *  the Free Software Foundation; either version 3 of the License, or      *
 *  (at your option) any later version.                                    *
 *                                                                         *
 *  sTerm is distributed in the hope that it will be useful,               *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *  GNU General Public License for more details.                           *
 *                                                                         *
 *  You should have received a copy of the GNU General Public License      *
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>   *
 ***************************************************************************/

#include "../include/stermkey.h"

//----------------------------------------------------------------------------//
//                                                                            //
//----------------------------------------------------------------------------//
StermKey::StermKey( string val,
                    string label,
                    string shift_val,
                    string shift_label,
                    string ctrl_val,
                    string ctrl_label
                    )
{
  this->val = val;                    
  this->label = label;
  this->shift_val = shift_val;
  this->shift_label = shift_label;
  this->ctrl_val = ctrl_val;
  this->ctrl_label = ctrl_label;
}

//----------------------------------------------------------------------------//
//                                                                            //
//----------------------------------------------------------------------------//
StermKey::StermKey( string val,
                    string label,
                    string shift_val,
                    string shift_label
                    )
{
  this->val = val;                    
  this->label = label;
  this->shift_val = shift_val;
  this->shift_label = shift_label;
  this->ctrl_val = val;
  this->ctrl_label = label;
}

//----------------------------------------------------------------------------//
//                                                                            //
//----------------------------------------------------------------------------//
StermKey::StermKey( string val,
                    string label
                    )
{
  this->val = val;                    
  this->label = label;
  this->shift_val = val;
  this->shift_label = label;
  this->ctrl_val = val;
  this->ctrl_label = label;
}

//----------------------------------------------------------------------------//
//                                                                            //
//----------------------------------------------------------------------------//
StermKey::StermKey( string val )
{
  this->val = val;                    
  this->label = val;
  this->shift_val = val;
  this->shift_label = val;
  this->ctrl_val = val;
  this->ctrl_label = val;
}

//----------------------------------------------------------------------------//
//                                                                            //
//----------------------------------------------------------------------------//
string StermKey::Get_Val()
{
       return this->val;
}

//----------------------------------------------------------------------------//
//                                                                            //
//----------------------------------------------------------------------------//
string StermKey::Get_Label()
{
       return this->label;       
}

//----------------------------------------------------------------------------//
//                                                                            //
//----------------------------------------------------------------------------//
string StermKey::Get_Shift_Val()
{
       return this->shift_val;
}

//----------------------------------------------------------------------------//
//                                                                            //
//----------------------------------------------------------------------------//
string StermKey::Get_Shift_Label()
{
       return this->shift_label;       
}

//----------------------------------------------------------------------------//
//                                                                            //
//----------------------------------------------------------------------------//
string StermKey::Get_Ctrl_Val()
{
       return this->ctrl_val;
}

//----------------------------------------------------------------------------//
//                                                                            //
//----------------------------------------------------------------------------//
string StermKey::Get_Ctrl_Label()
{
       return this->ctrl_label;
}
